
Ruby - Bug #4561

1.9.2 requires parentheses around argument of method call in an array, where 1.8.7 did not

04/07/2011 01:41 PM - dschweisguth (Dave Schweisguth)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version: 1.9.3   

ruby -v: - Backport:  

Description

[dave hladik:~] cat method_call_without_parens_in_array.rb

def method_name(arg)

end

[ method_name 'value' ]

[dave hladik:~] ruby -v

ruby 1.8.7 (2011-02-18 patchlevel 334) [i686-darwin10]

[dave hladik:~] ruby method_call_without_parens_in_array.rb

[dave hladik:~] rvm 1.9.2

[dave hladik:~] ruby -v

ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin10.7.0]

[dave hladik:~] ruby method_call_without_parens_in_array.rb

method_call_without_parens_in_array.rb:4: syntax error, unexpected tSTRING_BEG, expecting keyword_do or '{' or '('

[ method_name 'value' ]

^

method_call_without_parens_in_array.rb:4: syntax error, unexpected ']', expecting $end

[dave hladik:~] rvm system

[dave hladik:~] ruby -v

ruby 1.8.7 (2011-02-18 patchlevel 334) [i686-darwin10]

[dave hladik:~] cat method_call_with_parens_in_array.rb

def method_name(arg)

end

[ method_name('value') ]

[dave hladik:~] ruby -v

ruby 1.8.7 (2011-02-18 patchlevel 334) [i686-darwin10]

[dave hladik:~] ruby method_call_with_parens_in_array.rb

[dave hladik:~] rvm 1.9.2

[dave hladik:~] ruby -v

ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin10.7.0]

[dave hladik:~] ruby method_call_with_parens_in_array.rb

no error

History

#1 - 04/07/2011 01:47 PM - dschweisguth (Dave Schweisguth)

=begin

Same thing with pre formatting:

[dave hladik:~] cat method_call_without_parens_in_array.rb

def method_name(arg)

end

[ method_name 'value' ]

[dave hladik:~] rvm system

[dave hladik:~] ruby -v

ruby 1.8.7 (2011-02-18 patchlevel 334) [i686-darwin10]

[dave hladik:~] ruby method_call_without_parens_in_array.rb

[dave hladik:~] rvm 1.9.2

[dave hladik:~] ruby -v

ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin10.7.0]

[dave hladik:~] ruby method_call_without_parens_in_array.rb
method_call_without_parens_in_array.rb:4: syntax error, unexpected tSTRING_BEG, expecting keyword_do or '{' or '('

[ method_name 'value' ]

^

method_call_without_parens_in_array.rb:4: syntax error, unexpected ']', expecting $end

[dave hladik:~] cat method_call_with_parens_in_array.rb

def method_name(arg)

end

[ method_name('value') ]

[dave hladik:~] rvm system

[dave hladik:~] ruby -v

ruby 1.8.7 (2011-02-18 patchlevel 334) [i686-darwin10]

[dave hladik:~] ruby method_call_with_parens_in_array.rb

[dave hladik:~] rvm 1.9.2

[dave hladik:~] ruby method_call_with_parens_in_array.rb

no error

=end

#2 - 04/07/2011 03:27 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

=begin

=end

#3 - 04/08/2011 01:09 AM - Eregon (Benoit Daloze)

=begin

That has bitten me a few times too, but I accepted it as it is probably clearer in a long expression.

I'm curious to see why this changed.

=end

#4 - 06/11/2011 03:58 PM - ko1 (Koichi Sasada)

Matz, could you reply?

#5 - 06/11/2011 10:53 PM - matz (Yukihiro Matsumoto)

- ruby -v changed from ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin10.7.0] to -

Hi,

In message "Re: [ruby-core:36994] [Ruby 1.9 - Bug #4561] 1.9.2 requires parentheses around argument of method call in an array, where 1.8.7 did

not"

on Sat, 11 Jun 2011 15:58:33 +0900, Koichi Sasada redmine@ruby-lang.org writes:

|Bug #4561: 1.9.2 requires parentheses around argument of method call in an array, where 1.8.7 did not

|http://redmine.ruby-lang.org/issues/4561

|

|Matz, could you reply?

It's an intentional syntax change in 1.9.

      matz.

#6 - 06/17/2011 09:48 AM - Anonymous

Yukihiro Matsumoto wrote:

It's an intentional syntax change in 1.9.

 I have run into the same issue today and wasn't sure if it was a bug or intentional. Nice to find both this issue and your recent response.

Out of curiosity, what is the reasoning behind this change? It seems a bit unintuitive that foo(bar 5) and {bar 5} work, even [bar { baz }], but [bar 5] not.

All four are enclosed calls without parenthesis. Is there an ambiguity nearby that this syntax change is trying to clarify?
#7 - 06/26/2011 07:02 PM - nahi (Hiroshi Nakamura)

- Assignee changed from matz (Yukihiro Matsumoto) to ko1 (Koichi Sasada)

- Target version set to 1.9.3

#8 - 06/26/2011 07:49 PM - ko1 (Koichi Sasada)

- Status changed from Assigned to Closed

Files

method_call_without_parens_in_array.rb 50 Bytes 04/07/2011 dschweisguth (Dave Schweisguth)

method_call_with_parens_in_array.rb 51 Bytes 04/07/2011 dschweisguth (Dave Schweisguth)
